image: gableroux/unity3d:2019.3.0f1

stages:
  - build_and_test
  - deploy

# If you are looking for a place where to add 'UNITY_LICENSE_FILE' nad secrets, please visit your project's gitlab page:
# settings > CI/CD > Variables instead
variables:
  BUILD_NAME: MaTcheDD
  UNITY_ACTIVATION_FILE: ./unity3d.alf
  GIT_SUBMODULE_STRATEGY: recursive

.unity_before_script: &unity_before_script
  before_script:
    - chmod +x ./ci/before_script.sh && ./ci/before_script.sh
    - apt-get update
    - apt-get install openssh-client git-core -y
    - eval $(ssh-agent -s)
    - echo "$CI_KEY" | tr -d '\r' | ssh-add - > /dev/null
    - mkdir -p ~/.ssh && touch ~/.ssh/known_hosts
    - echo "$SSH_KNOWN_HOSTS" >> ~/.ssh/known_hosts
    - git config --global user.email "r.hamers@bluetea.nl"
    - git config --global user.name "ruben.hamers"
#    - git submodule init
#    - git submodule update

.cache: &cache
  cache:
    key: "$CI_PROJECT_NAMESPACE-$CI_PROJECT_NAME-$CI_COMMIT_REF_SLUG-$TEST_PLATFORM"
    paths:
      - Library/

# run this job when you need to request a license
# you may need to follow activation steps from documentation
get-activation-file:
  when: manual
  stage: build_and_test
  script:
    - chmod +x ./ci/get_activation_file.sh && ./ci/get_activation_file.sh
  artifacts:
    paths:
      - $UNITY_ACTIVATION_FILE
    expire_in: 10 min # Expiring this as artifacts may contain sensitive data and should not be kept public
  only: 
    - develop
    - master

.test: &test
  stage: build_and_test
  <<: *unity_before_script
  <<: *cache
  script:
    - chmod +x ./ci/test.sh && ./ci/test.sh
  artifacts:
    paths:
      - $(pwd)/$TEST_PLATFORM-results.xml
  only:
    - develop
    - master

test-playmode:
  <<: *test
  variables:
    TEST_PLATFORM: playmode

test-editmode:
  <<: *test
  variables:
    TEST_PLATFORM: editmode

.build: &build
  stage: build_and_test
  <<: *unity_before_script
  <<: *cache
  script:
    - chmod +x ./ci/build.sh && ./ci/build.sh
  artifacts:
    paths:
      - ./Builds/
  only:
    - master

build-StandaloneLinux64:
  <<: *build
  variables:
    BUILD_TARGET: StandaloneLinux64

#build-StandaloneWindows64:
#  <<: *build
#  image: gableroux/unity3d:2019.2.14f1-windows
#  variables:
#    BUILD_TARGET: StandaloneWindows64

#build-android:
#  <<: *build
#  image: gableroux/unity3d:2019.2.11f1-android
#  variables:
#    BUILD_TARGET: Android

pages:
  image: alpine:latest
  stage: deploy
  script:
    - mv "./Builds/WebGL/${BUILD_NAME}" public
  artifacts:
    paths:
      - public
  only:
    - master